routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/


Route::get('/', function () {
    return redirect()->route('frontend.home');
});


// Guest Users
Route::middleware(['guest','PreventBackHistory'])->group(function()
{
    // Admin Routes
    Route::get('admin/login', [App\Http\Controllers\Admin\AuthController::class, 'showLogin'])->name('admin.home');
    Route::get('login', [App\Http\Controllers\Admin\AuthController::class, 'showLogin'] )->name('login');
    Route::post('login', [App\Http\Controllers\Admin\AuthController::class, 'login'])->name('signin');
    Route::get('signup', [App\Http\Controllers\Admin\AuthController::class, 'showRegister'] )->name('register');
    Route::post('signup', [App\Http\Controllers\Admin\AuthController::class, 'register'])->name('signup');


});



// Authenticated users
Route::middleware(['auth','PreventBackHistory'])->group(function()
{

    // Auth Routes
    Route::get('edit-profile', [App\Http\Controllers\Admin\DashboardController::class, 'editProfile'] )->name('edit-profile');
    // Route::get('home', fn () => redirect()->route('dashboard'))->name('home');
    Route::post('logout', [App\Http\Controllers\Admin\AuthController::class, 'Logout'])->name('logout');
    Route::get('show-change-password', [App\Http\Controllers\Admin\AuthController::class, 'showChangePassword'] )->name('show-change-password');
    Route::post('change-password', [App\Http\Controllers\Admin\AuthController::class, 'changePassword'] )->name('change-password');


    // Dashboard routes
    Route::get('dashboard', [App\Http\Controllers\Admin\DashboardController::class, 'index'])->name('dashboard');

    // Masters Route
    Route::resource('wards', App\Http\Controllers\Admin\Masters\WardController::class );
    Route::resource('locations', App\Http\Controllers\Admin\Masters\LocationController::class );
    Route::resource('banners', App\Http\Controllers\Admin\Masters\BannerController::class );
    Route::resource('police_stations', App\Http\Controllers\Admin\Masters\PoliceStationController::class );
    Route::resource('documents', App\Http\Controllers\Admin\Masters\DocumentController::class );

    // User Route
    Route::get('advertise-permission', [App\Http\Controllers\Frontend\UserController::class, 'index'] )->name('advertise-permission');

    // Admin Registration
    Route::resource('users', App\Http\Controllers\Admin\AdminController::class );

    // Police Routes
    Route::get('permission-requests/{id}', [App\Http\Controllers\Admin\PoliceController::class, 'index'] )->name('permission-requests');
    Route::get('permission-requests-ward/{id}/{ward_id}', [App\Http\Controllers\Admin\PoliceController::class, 'wardWiseList'] )->name('permission-requests-ward');
    Route::get('view-application/{id}', [App\Http\Controllers\Admin\PoliceController::class, 'viewApplication'] )->name('view-application');
    // Route::get('approve-application/{id}', [App\Http\Controllers\Admin\PoliceController::class, 'ApproveApplication'] )->name('approve-application');        // TODO: this function is no longer in use
    // Route::put('reject-application/{id}', [App\Http\Controllers\Admin\PoliceController::class, 'RejectApplication'] )->name('reject-application');

    // Frontend Auth Routes
    Route::get('terms-conditions', [App\Http\Controllers\Frontend\UserController::class, 'termsCondition'] )->name('terms-conditions');
    Route::get('application_form', [App\Http\Controllers\Frontend\UserController::class, 'applicationForm'] )->name('application-form');
    Route::get('application-form', [App\Http\Controllers\Frontend\UserController::class, 'applicationForm'] )->name('frontend.application-form');
    Route::get('wards/{ward}/locations', [App\Http\Controllers\Admin\Masters\WardController::class, 'wardWiseLocations'] )->name('wards.locations');
    Route::get('locations/{location}/from_date', [App\Http\Controllers\Admin\Masters\LocationController::class, 'locationWiseFromdate'] )->name('locations.dates');
    Route::get('application/to_date/{date}', [App\Http\Controllers\Frontend\UserController::class, 'getApplicationToDate'] )->name('application.to-date');
    Route::post('application-form', [App\Http\Controllers\Frontend\UserController::class, 'submitApplication'] )->name('frontend.submit-application');

    Route::get('cancel-application-list', [App\Http\Controllers\Frontend\UserController::class, 'cancelApplicationList'] )->name('cancel-application-list');
    Route::put('cancel-application/{application}', [App\Http\Controllers\Frontend\UserController::class, 'cancelApplication'] )->name('cancel-application');
    Route::get('qr-code-list', [App\Http\Controllers\Frontend\UserController::class, 'qrCodeList'] )->name('qr-code-list');
    Route::get('download-qr-code/{application}', [App\Http\Controllers\Frontend\UserController::class, 'downloadQrCode'] )->name('download-qr-code');
    Route::get('certificate-list', [App\Http\Controllers\Frontend\UserController::class, 'certificateList'] )->name('certificate-list');
    Route::get('download-certificate/{application}', [App\Http\Controllers\Frontend\UserController::class, 'downloadCertificate'] )->name('download-certificate');

    Route::get('payment-list/{id}', [App\Http\Controllers\Frontend\PaymentController::class, 'paymentList'] )->name('payment-list');
    Route::get('initiate-payment/{application}', [App\Http\Controllers\Frontend\PaymentController::class, 'initiatePayment'] )->name('initiate-payment');
    Route::post('payment-success', [App\Http\Controllers\Frontend\PaymentController::class, 'paymentSuccess'] )->name('payment-success');
    // Route::get('payment-success-page', [App\Http\Controllers\Frontend\PaymentController::class, 'paymentSuccessPage'] )->name('payment-success-page');
    Route::post('payment-failed', [App\Http\Controllers\Frontend\PaymentController::class, 'paymentFailed'] )->name('payment-failed');
    // Route::get('payment-failed-page', [App\Http\Controllers\Frontend\PaymentController::class, 'paymentFailedPage'] )->name('payment-failed-page');
});




// Frontend Guest Routes
Route::get('/home', [App\Http\Controllers\Frontend\AuthController::class, 'home'])->name('frontend.home');
Route::get('/scan-certificate/{application}', [App\Http\Controllers\Frontend\UserController::class, 'showCertificate'])->name('frontend.show-certificate');

app/Http/Controllers/Admin/Masters/BannerController.php
<?php

namespace App\Http\Controllers\Admin\Masters;

use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\Masters\StoreBannerRequest;
use App\Http\Requests\Admin\Masters\UpdateBannerRequest;
use App\Models\Banner;
use Illuminate\Support\Arr;
use Illuminate\Support\Facades\DB;

class BannerController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $banners = Banner::latest()->get();
        return view('admin.masters.banners')->with(['banners'=> $banners]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

     /**
     * Store a newly created resource in storage.
     */
    public function store(StoreBannerRequest $request)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            Banner::create( Arr::only( $input, Banner::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Banner Details created successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'creating', 'Banner Details');
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Banner $banner)
    {
        if ($banner)
        {
            $response = [
                'result' => 1,
                'banner' => $banner
            ];
        }
        else
        {
            $response = ['result' => 0];
        }
        return $response;
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateBannerRequest $request, Banner $banner)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            $banner->update( Arr::only( $input, Banner::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Banner Details updated successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'updating', 'Banner Details');
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Banner $banner)
    {
        try
        {
            DB::beginTransaction();
            $banner->delete();
            DB::commit();
            return response()->json(['success'=> 'Banner Details deleted successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'deleting', 'Banner Details');
        }
    }

}

app/Http/Controllers/Admin/Masters/DocumentController.php
<?php

namespace App\Http\Controllers\Admin\Masters;

use App\Http\Controllers\Admin\Controller;
use App\Http\Requests\Admin\Masters\StoreDocumentRequest;
use App\Http\Requests\Admin\Masters\UpdateDocumentRequest;
use App\Models\Document;
use Illuminate\Support\Arr;
use Illuminate\Support\Facades\DB;

class DocumentController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $documents = Document::latest()->get();
        return view('admin.masters.documents')->with(['documents'=> $documents]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StoreDocumentRequest $request)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            Document::create( Arr::only( $input, Document::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Document created successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'creating', 'Document');
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Document $document)
    {
        if ($document)
        {
            $response = [
                'result' => 1,
                'document' => $document
            ];
        }
        else
        {
            $response = ['result' => 0];
        }
        return $response;
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateDocumentRequest $request, Document $document)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            $document->update( Arr::only( $input, Document::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Document updated successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'updating', 'Document');
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Document $document)
    {
        try
        {
            DB::beginTransaction();
            $document->delete();
            DB::commit();
            return response()->json(['success'=> 'Document deleted successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'deleting', 'Document');
        }
    }
}

app/Http/Controllers/Admin/Masters/LocationController.php
<?php

namespace App\Http\Controllers\Admin\Masters;

use App\Http\Controllers\Admin\Controller;
use App\Http\Requests\Admin\Masters\StoreLocationRequest;
use App\Http\Requests\Admin\Masters\UpdateLocationRequest;
use App\Models\HoardingPermission;
use App\Models\Location;
use App\Models\LocationBookedDate;
use App\Models\Ward;
use Carbon\Carbon;
use Carbon\CarbonPeriod;
use Illuminate\Http\Request;
use Illuminate\Support\Arr;
use Illuminate\Support\Facades\DB;

class LocationController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $locations = Location::latest()->get();
        $wards = Ward::latest()->get();
        return view('admin.masters.locations')->with(['locations'=> $locations,'wards'=>$wards]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StoreLocationRequest $request)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            Location::create( Arr::only( $input, Location::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Location created successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'creating', 'Location');
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Location $location)
    {
        $wards = Ward::latest()->get();
        if ($location)
        {
            $wardHtml = '<span>
                <option value="">--Select Ward--</option>';
                foreach($wards as $ward):
                    $is_select = $ward->id == $location->ward_id ? "selected" : "";
                    $wardHtml .= '<option value="'.$ward->id.'" '.$is_select.'>'.$ward->name.'</option>';
                endforeach;
            $wardHtml .= '</span>';

            $response = [
                'result' => 1,
                'location' => $location,
                'wardHtml' => $wardHtml,
            ];
        }
        else
        {
            $response = ['result' => 0];
        }
        return $response;
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateLocationRequest $request, Location $location)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            $location->update( Arr::only( $input, Location::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Location updated successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'updating', 'Location');
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Location $location)
    {
        try
        {
            DB::beginTransaction();
            $location->delete();
            DB::commit();
            return response()->json(['success'=> 'Location deleted successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'deleting', 'Location');
        }
    }


    public function locationWiseFromdate(Request $request, Location $location)
    {
        // $fromDate = Carbon::today()->addDays(config('setting.interval_days'))->toDateString();
        $fromDate = Carbon::today()->toDateString();
        $toDate = Carbon::parse($fromDate)->addMonth()->toDateString();
        $dateRanges = CarbonPeriod::create( Carbon::parse($fromDate), Carbon::parse($toDate) )->toArray();
        $newDateArray = [];
        foreach($dateRanges as $dateRange)
            $newDateArray[] = $dateRange->toDateString();

        // $locationBookingDates = LocationBookedDate::where('payment_status', 0)->where('location_id', $location->id)->pluck('date')->toArray();
        $locationBookingDates = [];

        $newDateArray = array_diff($newDateArray, $locationBookingDates);

        $dateHtml = '<span>
            <option value="">Select Date</option>';
            foreach($newDateArray as $date):
                $dateHtml .= '<option value="'.$date.'" >'.$date.'</option>';
            endforeach;
        $dateHtml .= '</span>';

        return [ 'result' => 1, 'dateHtml' => $dateHtml ];
    }


}

resources/views/admin/masters/banners.blade.php
<x-admin.layout>
    <x-slot name="title" >Banner Details</x-slot>
    <x-slot name="breadcrumb">Banner Details</x-slot>

    <!-- Add Form -->
    <div class="row" id="addContainer" style="display:none;">
        <div class="col-sm-12">
            <div class="card">
                <h2 class="fs-lg fw-medium me-auto" style="margin: 15px">Add Banner Details</h2>
                <form class="theme-form" name="addForm" id="addForm" enctype="multipart/form-data">
                    @csrf

                    <div class="card-body">
                        <div class="mb-3 row">

                            <div class="col-md-4">
                                <label class="col-form-label" for="banner_size"> Banner Size <span class="text-danger">*</span></label>
                                <input class="form-control" name="banner_size" type="text" placeholder="Enter Banner Size">
                                <span class="pristine-error text-theme-6 mt-1 banner_size_err"></span>
                            </div>

                            <div class="col-md-4">
                                <label class="col-form-label" for="amount"> Fees <span class="text-danger">*</span></label>
                                <input class="form-control" name="amount" type="text" placeholder="Enter Fees">
                                <span class="pristine-error text-theme-6 mt-1 amount_err"></span>
                            </div>

                        </div>
                    </div>
                    <div class="card-footer">
                        <button type="submit" class="btn btn-primary" id="addSubmit">Submit</button>
                        <button type="reset" class="btn btn-warning">Reset</button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    {{-- Edit Form --}}
    <div class="row" id="editContainer" style="display:none;">
        <div class="col">
            <form class="form-horizontal form-bordered" method="post" id="editForm">
                @csrf
                <section class="card">
                    <h2 class="fs-lg fw-medium me-auto" style="margin: 15px">Edit Banner Details</h2>

                    <div class="card-body py-2">

                        <input type="hidden" id="edit_model_id" name="edit_model_id" value="">
                        <div class="mb-3 row">

                            <div class="col-md-4">
                                <label class="col-form-label" for="banner_size"> Banner Size <span class="text-danger">*</span></label>
                                <input class="form-control" name="banner_size" type="text" placeholder="Enter Banner Size">
                                <span class="pristine-error text-theme-6 mt-1 banner_size_err"></span>
                            </div>

                            <div class="col-md-4">
                                <label class="col-form-label" for="amount"> Fees <span class="text-danger">*</span></label>
                                <input class="form-control" name="amount" type="text" placeholder="Enter Fees">
                                <span class="pristine-error text-theme-6 mt-1 amount_err"></span>
                            </div>

                        </div>

                    </div>
                    <div class="card-footer">
                        <button class="btn btn-primary" id="editSubmit">Submit</button>
                        <button type="reset" class="btn btn-warning">Reset</button>
                    </div>
                </section>
            </form>
        </div>
    </div>

    <div class="intro-y box p-5 mt-5">
        <div class="d-flex flex-column flex-sm-row align-items-sm-end align-items-xl-start mb-3">
            <div class="row">
                <div class="col-sm-6">
                    <div class="d-flex">
                        <button id="addToTable" class="btn btn-primary me-2 px-5"><i class="fa fa-plus"></i> &nbsp;Add</button>
                        <button id="btnCancel" class="btn btn-danger ms-2 px-5" style="display:none;">Cancel</button>
                    </div>
                </div>
            </div>
        </div>

        <div class="overflow-x-auto scrollbar-hidden">
            <div class="table-responsive">
                <table class="table-bordered" id="datatable-tabletools">
                    <thead>
                        <tr>
                            <th>Sr No</th>
                            <th>Banner Size</th>
                            <th>Fee</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($banners as $banner)
                        <tr>
                                <td>{{ $loop->iteration }}</td>
                                <td>{{ $banner?->banner_size }}</td>
                                <td>{{ $banner?->amount }}</td>
                                <td>
                                    <button class="edit-element btn px-2 py-1" title="Edit banner" data-id="{{ $banner->id }}"><i class="far fa-pen-to-square"></i> &nbsp;Edit</button>
                                    <button class="btn text-danger rem-element px-2 py-1" title="Delete banner" data-id="{{ $banner->id }}"><i class="far fa-trash-can"></i> &nbsp;Delete</button>
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        </div>


    </div>
    @push('scripts')


        {{-- Add --}}
        <script>
            $("#addForm").submit(function(e) {
                e.preventDefault();
                $("#addSubmit").prop('disabled', true);

                var formdata = new FormData(this);
                $.ajax({
                    url: '{{ route('banners.store') }}',
                    type: 'POST',
                    data: formdata,
                    contentType: false,
                    processData: false,
                    success: function(data)
                    {
                        $("#addSubmit").prop('disabled', false);
                        if (!data.error2)
                            swal("Successful!", data.success, "success")
                                .then((action) => {
                                    window.location.href = '{{ route('banners.index') }}';
                                });
                        else
                            swal("Error!", data.error2, "error");
                    },
                    statusCode: {
                        422: function(responseObject, textStatus, jqXHR) {
                            $("#addSubmit").prop('disabled', false);
                            resetErrors();
                            printErrMsg(responseObject.responseJSON.errors);
                        },
                        500: function(responseObject, textStatus, errorThrown) {
                            $("#addSubmit").prop('disabled', false);
                            swal("Error occured!", "Something went wrong please try again", "error");
                        }
                    }
                });

            });
        </script>


        <!-- Edit -->
        <script>
            $("#datatable-tabletools").on("click", ".edit-element", function(e) {
                e.preventDefault();
                $(".edit-element").show();
                var model_id = $(this).attr("data-id");
                var url = "{{ route('banners.edit', ":model_id") }}";

                $.ajax({
                    url: url.replace(':model_id', model_id),
                    type: 'GET',
                    data: {
                        '_token': "{{ csrf_token() }}"
                    },
                    success: function(data, textStatus, jqXHR) {
                        editFormBehaviour();

                        if (!data.error)
                        {
                            $("#editForm input[name='edit_model_id']").val(data.banner.id);
                            $("#editForm input[name='banner_size']").val(data.banner.banner_size);
                            $("#editForm input[name='amount']").val(data.banner.amount);
                        }
                        else
                        {
                            alert(data.error);
                        }
                    },
                    error: function(error, jqXHR, textStatus, errorThrown) {
                        alert("Some thing went wrong");
                    },
                });
            });
        </script>


         <!-- Update -->
         <script>
            $(document).ready(function() {
                $("#editForm").submit(function(e) {
                    e.preventDefault();
                    $("#editSubmit").prop('disabled', true);
                    var formdata = new FormData(this);
                    formdata.append('_method', 'PUT');
                    var model_id = $('#edit_model_id').val();
                    var url = "{{ route('banners.update', ":model_id") }}";
                    //
                    $.ajax({
                        url: url.replace(':model_id', model_id),
                        type: 'POST',
                        data: formdata,
                        contentType: false,
                        processData: false,
                        success: function(data)
                        {
                            $("#editSubmit").prop('disabled', false);
                            if (!data.error2)
                                swal("Successful!", data.success, "success")
                                    .then((action) => {
                                        window.location.href = '{{ route('banners.index') }}';
                                    });
                            else
                                swal("Error!", data.error2, "error");
                        },
                        statusCode: {
                            422: function(responseObject, textStatus, jqXHR) {
                                $("#editSubmit").prop('disabled', false);
                                resetErrors();
                                printErrMsg(responseObject.responseJSON.errors);
                            },
                            500: function(responseObject, textStatus, errorThrown) {
                                $("#editSubmit").prop('disabled', false);
                                swal("Error occured!", "Something went wrong please try again", "error");
                            }
                        }
                    });


                });
            });
        </script>


        <!-- Delete -->
        <script>
            $("#datatable-tabletools").on("click", ".rem-element", function(e) {
                e.preventDefault();
                swal({
                    title: "Are you sure to delete this Banner Details?",
                    // text: "Make sure if you have filled Vendor details before proceeding further",
                    icon: "info",
                    buttons: ["Cancel", "Confirm"]
                })
                .then((justTransfer) =>
                {
                    if (justTransfer)
                    {
                        var model_id = $(this).attr("data-id");
                        var url = "{{ route('banners.destroy', ":model_id") }}";

                        $.ajax({
                            url: url.replace(':model_id', model_id),
                            type: 'POST',
                            data: {
                                '_method': "DELETE",
                                '_token': "{{ csrf_token() }}"
                            },
                            success: function(data, textStatus, jqXHR) {
                                if (!data.error && !data.error2) {
                                    swal("Success!", data.success, "success")
                                        .then((action) => {
                                            window.location.reload();
                                        });
                                } else {
                                    if (data.error) {
                                        swal("Error!", data.error, "error");
                                    } else {
                                        swal("Error!", data.error2, "error");
                                    }
                                }
                            },
                            error: function(error, jqXHR, textStatus, errorThrown) {
                                swal("Error!", "Something went wrong", "error");
                            },
                        });
                    }
                });
            });
        </script>

    @endpush

</x-admin.layout>